# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class BatchQueryStatus(str, Enum):
    """
    The localized status of the query task: - submitted: The query was submitted to the query executor for processing. - pending: The query was waiting for being processed. - executing: The query is being processed. - completed: The query was successfully executed. - aborted: The query execution failed. - deleted_notallowed: The query execution failed because objects included in the query do not support the querying of deleted records. 
    """

    """
    allowed enum values
    """
    SUBMITTED = 'submitted'
    PENDING = 'pending'
    EXECUTING = 'executing'
    COMPLETED = 'completed'
    ABORTED = 'aborted'
    DELETED_NOTALLOWED = 'deleted_notallowed'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of BatchQueryStatus from a JSON string"""
        return cls(json.loads(json_str))


