# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class BillRunStatus(str, Enum):
    """
    A bill run can have one of the following possible [statuses](https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Automate_billing_document_generation/Bill_runs/AA_Get_started_with_bill_runs#Bill_run_status_types).  The status provides information about how the bill run is being processed in Zuora. 
    """

    """
    allowed enum values
    """
    PENDING = 'Pending'
    PROCESSING = 'Processing'
    COMPLETED = 'Completed'
    ERROR = 'Error'
    CANCELED = 'Canceled'
    POSTED = 'Posted'
    POSTINPROGRESS = 'PostInProgress'
    CANCELINPROGRESS = 'CancelInProgress'
    REMOVEINPROGRESS = 'RemoveInProgress'
    PAUSED = 'Paused'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of BillRunStatus from a JSON string"""
        return cls(json.loads(json_str))


