# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class BillRunType(str, Enum):
    """
    Type of the bill run. * `Regular` - The normal bill run that produces invoices. * `CatchUp` - A catch up bill run that does not generate any invoices.  See [Catch-Up Bill Run](https://knowledgecenter.zuora.com/Zuora_Billing/Bill_your_customers/Automate_billing_document_generation/Bill_runs/Z_Catch-Up_Bill_Run) for more information 
    """

    """
    allowed enum values
    """
    REGULAR = 'Regular'
    CATCHUP = 'CatchUp'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of BillRunType from a JSON string"""
        return cls(json.loads(json_str))


