# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.add_subscription_component import AddSubscriptionComponent
from typing import Optional, Set
from typing_extensions import Self

class ChangeSubscriptionRatePlan(BaseModel):
    """
    ChangeSubscriptionRatePlan
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    booking_date: Optional[date] = Field(default=None, description="The booking date that you want to set for the amendment contract. The booking date of an amendment is the equivalent of the order date of an order. This field must be in the `yyyy-mm-dd` format. The default value is the current date when you make the API call.  ", alias="bookingDate")
    charge_overrides: Optional[List[AddSubscriptionComponent]] = Field(default=None, description="This optional container is used to override one or more product rate plan charges for this subscription.", alias="chargeOverrides")
    contract_effective_date: Optional[date] = Field(default=None, description="Effective date of the new subscription, as yyyy-mm-dd.", alias="contractEffectiveDate")
    customer_acceptance_date: Optional[date] = Field(default=None, description="The date when the customer accepts the contract in yyyy-mm-dd format. When this field is not set: * If the `serviceActivationDate` field is not set, the value of this field is set to be the contract effective date. * If the `serviceActivationDate` field is set, the value of this field is set to be the service activation date.  The billing trigger dates must follow this rule: contractEffectiveDate <= serviceActivationDate <= contractAcceptanceDate ", alias="customerAcceptanceDate")
    effective_policy: Optional[StrictStr] = Field(default=None, description="The default value for the `effectivePolicy` field is as follows:   * If the rate plan change (from old to new) is an upgrade, the effective policy is `EffectiveImmediately` by default.   * If the rate plan change (from old to new) is a downgrade, the effective policy is `EffectiveEndOfBillingPeriod` by default.   * Otherwise, the effective policy is `SpecificDate` by default.  Note that if the `effectivePolicy` field is set to `EffectiveEndOfBillingPeriod`, you cannot set the <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Subscriptions/Subscriptions/W_Subscription_and_Amendment_Dates#Billing_Trigger_Dates\" target=\"_blank\">billing trigger dates</a> for the subscription as the system will automatically set the trigger dates to the end of billing period. ", alias="effectivePolicy")
    external_catalog_plan_id: Optional[StrictStr] = Field(default=None, description="An external ID of the rate plan to be removed. You can use this field to specify an existing rate plan in your subscription. The value of the `externalCatalogPlanId` field must match one of the values that are predefined in the `externallyManagedPlanIds` field on a product rate plan. However, if there are multiple rate plans with the same `productRatePlanId` value existing in the subscription, you must use the `ratePlanId` field to remove the rate plan. The `externalCatalogPlanId` field cannot be used to distinguish multiple rate plans in this case.  **Note:** Provide only one of `externalCatalogPlanId`, `ratePlanId` or `productRatePlanId`. If more than one field is provided then the request would fail. ", alias="externalCatalogPlanId")
    external_id_source_system: Optional[StrictStr] = Field(default=None, description="The ID of the external source system. You can use this field and `externalCatalogPlanId` to specify a product rate plan that is imported from an external system.  **Note:** If both `externalCatalogPlanId`, `externalIdSourceSystem` and `productRatePlanId` are provided. They must point to the same product rate plan. Otherwise, the request would fail. ", alias="externalIdSourceSystem")
    new_external_catalog_plan_id: Optional[StrictStr] = Field(default=None, description="An external ID of the product rate plan to be added. You can use this field to specify a product rate plan that is imported from an external system. The value of the `externalCatalogPlanId` field must match one of the values that are predefined in the `externallyManagedPlanIds` field on a product rate plan.  **Note:** Provide only one of `newExternalCatalogPlanId` or `newProductRatePlanId`. If both fields are provided then the request would fail. ", alias="newExternalCatalogPlanId")
    new_external_id_source_system: Optional[StrictStr] = Field(default=None, description="The ID of the external source system. You can use this field and `newExternalCatalogPlanId` to specify a product rate plan that is imported from an external system.  **Note:** If both `newExternalCatalogPlanId`, `newExternalIdSourceSystem` and `newProductRatePlanId` are provided. They must point to the same product rate plan. Otherwise, the request would fail. ", alias="newExternalIdSourceSystem")
    new_product_rate_plan_id: Optional[StrictStr] = Field(default=None, description="ID of a product rate plan for this subscription.", alias="newProductRatePlanId")
    new_product_rate_plan_number: Optional[StrictStr] = Field(default=None, description="Number of a product rate plan for this subscription.", alias="newProductRatePlanNumber")
    product_rate_plan_id: Optional[StrictStr] = Field(default=None, description="ID of the product rate plan that the removed rate plan is based on. ", alias="productRatePlanId")
    product_rate_plan_number: Optional[StrictStr] = Field(default=None, description="Number of a product rate plan for this subscription.    ", alias="productRatePlanNumber")
    rate_plan_id: Optional[StrictStr] = Field(default=None, description="ID of a rate plan to remove. Note that the removal of a rate plan through the Change Plan amendment supports the function of <a href=\"https://knowledgecenter.zuora.com/Zuora_Billing/Subscriptions/Subscriptions/Subscribe_and_Amend/E_Amendments/EB_Remove_rate_plan_on_subscription_before_future-dated_removals\" target=\"_blank\">removal before future-dated removals</a>, as in a Remove Product amendment. ", alias="ratePlanId")
    reset_bcd: Optional[StrictBool] = Field(default=False, description="If resetBcd is true then reset the Account BCD to the effective date; if it is false keep the original BCD. ", alias="resetBcd")
    service_activation_date: Optional[date] = Field(default=None, description="The date when the change in the subscription is activated in yyyy-mm-dd format. You must specify a Service Activation date if the Customer Acceptance date is set. If the Customer Acceptance date is not set, the value of the `serviceActivationDate` field defaults to be the Contract Effective Date. The billing trigger dates must follow this rule: contractEffectiveDate <= serviceActivationDate <= contractAcceptanceDate", alias="serviceActivationDate")
    sub_type: Optional[StrictStr] = Field(default=None, description="Use this field to choose the sub type for your change plan amendment.   However, if you do not set this field, the field will be automatically generated by the system according to the following rules:  When the old and new rate plans are within the same Grading catalog group: * If the grade of new plan is greater than that of the old plan, this is an \"Upgrade\". * If the grade of new plan is less than that of the old plan, this is a \"Downgrade\". * If the grade of new plan equals that of the old plan, this is a \"Crossgrade\".  When the old and new rate plans are not in the same Grading catalog group, or either has no group, this is \"PlanChanged\". ", alias="subType")
    subscription_rate_plan_number: Optional[StrictStr] = Field(default=None, description="Number of a rate plan for this subscription.  ", alias="subscriptionRatePlanNumber")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["bookingDate", "chargeOverrides", "contractEffectiveDate", "customerAcceptanceDate", "effectivePolicy", "externalCatalogPlanId", "externalIdSourceSystem", "newExternalCatalogPlanId", "newExternalIdSourceSystem", "newProductRatePlanId", "newProductRatePlanNumber", "productRatePlanId", "productRatePlanNumber", "ratePlanId", "resetBcd", "serviceActivationDate", "subType", "subscriptionRatePlanNumber"]

    @field_validator('effective_policy')
    def effective_policy_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['EffectiveImmediately', 'EffectiveEndOfBillingPeriod', 'SpecificDate']):
            raise ValueError("must be one of enum values ('EffectiveImmediately', 'EffectiveEndOfBillingPeriod', 'SpecificDate')")
        return value

    @field_validator('sub_type')
    def sub_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Upgrade', 'Downgrade', 'Crossgrade', 'PlanChanged']):
            raise ValueError("must be one of enum values ('Upgrade', 'Downgrade', 'Crossgrade', 'PlanChanged')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChangeSubscriptionRatePlan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in charge_overrides (list)
        _items = []
        if self.charge_overrides:
            for _item_charge_overrides in self.charge_overrides:
                if _item_charge_overrides:
                    _items.append(_item_charge_overrides.to_dict())
            _dict['chargeOverrides'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChangeSubscriptionRatePlan from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "bookingDate": obj.get("bookingDate"),
            "chargeOverrides": [AddSubscriptionComponent.from_dict(_item) for _item in obj["chargeOverrides"]] if obj.get("chargeOverrides") is not None else None,
            "contractEffectiveDate": obj.get("contractEffectiveDate"),
            "customerAcceptanceDate": obj.get("customerAcceptanceDate"),
            "effectivePolicy": obj.get("effectivePolicy"),
            "externalCatalogPlanId": obj.get("externalCatalogPlanId"),
            "externalIdSourceSystem": obj.get("externalIdSourceSystem"),
            "newExternalCatalogPlanId": obj.get("newExternalCatalogPlanId"),
            "newExternalIdSourceSystem": obj.get("newExternalIdSourceSystem"),
            "newProductRatePlanId": obj.get("newProductRatePlanId"),
            "newProductRatePlanNumber": obj.get("newProductRatePlanNumber"),
            "productRatePlanId": obj.get("productRatePlanId"),
            "productRatePlanNumber": obj.get("productRatePlanNumber"),
            "ratePlanId": obj.get("ratePlanId"),
            "resetBcd": obj.get("resetBcd") if obj.get("resetBcd") is not None else False,
            "serviceActivationDate": obj.get("serviceActivationDate"),
            "subType": obj.get("subType"),
            "subscriptionRatePlanNumber": obj.get("subscriptionRatePlanNumber")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
