# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ChargeModelProductRatePlanChargeRest(str, Enum):
    """
    Determines how to calculate charges. Charge models must be individually activated in Zuora Billing administration. 
    """

    """
    allowed enum values
    """
    DISCOUNT_MINUS_FIXED_AMOUNT = 'Discount-Fixed Amount'
    DISCOUNT_MINUS_PERCENTAGE = 'Discount-Percentage'
    FLAT_FEE_PRICING = 'Flat Fee Pricing'
    PER_UNIT_PRICING = 'Per Unit Pricing'
    OVERAGE_PRICING = 'Overage Pricing'
    TIERED_PRICING = 'Tiered Pricing'
    TIERED_WITH_OVERAGE_PRICING = 'Tiered with Overage Pricing'
    VOLUME_PRICING = 'Volume Pricing'
    DELIVERY_PRICING = 'Delivery Pricing'
    MULTIATTRIBUTEPRICING = 'MultiAttributePricing'
    PRERATEDPERUNIT = 'PreratedPerUnit'
    PRERATED_PRICING_BACKTICK = 'PreratedPricing`'
    HIGHWATERMARKVOLUMEPRICING = 'HighWatermarkVolumePricing'
    HIGHWATERMARKTIEREDPRICING = 'HighWatermarkTieredPricing'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ChargeModelProductRatePlanChargeRest from a JSON string"""
        return cls(json.loads(json_str))


