# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class CommitmentLevel(str, Enum):
    """
    **Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled.  Valid for the Charge with Function of `Prepayment` or `CommitmentTrueUp`. The level in which the funds are applicable for the usage drawdown charges during drawdown. * `RATEPLAN` - only usage charges of same rate plan can be drawn down. * `SUBSCRIPTION` - only usage charges of same subscription can be drawn down. * `ACCOUNT` - any usage charges in the same account (subscription owner) can be drawn down. 
    """

    """
    allowed enum values
    """
    RATEPLAN = 'RATEPLAN'
    SUBSCRIPTION = 'SUBSCRIPTION'
    ACCOUNT = 'ACCOUNT'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CommitmentLevel from a JSON string"""
        return cls(json.loads(json_str))


