# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ExpandedOrderAction(BaseModel):
    """
    ExpandedOrderAction
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    id: Optional[StrictStr] = None
    created_by_id: Optional[StrictStr] = Field(default=None, alias="createdById")
    created_date: Optional[StrictStr] = Field(default=None, alias="createdDate")
    updated_by_id: Optional[StrictStr] = Field(default=None, alias="updatedById")
    updated_date: Optional[StrictStr] = Field(default=None, alias="updatedDate")
    contract_effective_date: Optional[date] = Field(default=None, alias="contractEffectiveDate")
    customer_acceptance_date: Optional[date] = Field(default=None, alias="customerAcceptanceDate")
    type: Optional[StrictStr] = None
    sequence: Optional[StrictInt] = None
    subscription_version_amendment_id: Optional[StrictStr] = Field(default=None, alias="subscriptionVersionAmendmentId")
    order_id: Optional[StrictStr] = Field(default=None, alias="orderId")
    subscription_id: Optional[StrictStr] = Field(default=None, alias="subscriptionId")
    change_reason: Optional[StrictStr] = Field(default=None, alias="changeReason")
    subscription_number: Optional[StrictStr] = Field(default=None, alias="subscriptionNumber")
    service_activation_date: Optional[date] = Field(default=None, alias="serviceActivationDate")
    auto_renew: Optional[StrictBool] = Field(default=None, alias="autoRenew")
    renew_setting: Optional[StrictStr] = Field(default=None, alias="renewSetting")
    renewal_term: Optional[StrictInt] = Field(default=None, alias="renewalTerm")
    renewal_term_period_type: Optional[StrictStr] = Field(default=None, alias="renewalTermPeriodType")
    term_start_date: Optional[date] = Field(default=None, alias="termStartDate")
    term_type: Optional[StrictStr] = Field(default=None, alias="termType")
    current_term: Optional[StrictInt] = Field(default=None, alias="currentTerm")
    current_term_period_type: Optional[StrictStr] = Field(default=None, alias="currentTermPeriodType")
    suspend_date: Optional[date] = Field(default=None, alias="suspendDate")
    resume_date: Optional[date] = Field(default=None, alias="resumeDate")
    cancellation_effective_date: Optional[date] = Field(default=None, alias="cancellationEffectiveDate")
    cancellation_policy: Optional[StrictStr] = Field(default=None, alias="cancellationPolicy")
    payment_term: Optional[StrictStr] = Field(default=None, alias="paymentTerm")
    bill_to_contact_id: Optional[StrictStr] = Field(default=None, alias="billToContactId")
    invoice_group_number: Optional[StrictStr] = Field(default=None, alias="invoiceGroupNumber")
    invoice_template_id: Optional[StrictStr] = Field(default=None, alias="invoiceTemplateId")
    sequence_set_id: Optional[StrictStr] = Field(default=None, alias="sequenceSetId")
    ship_to_contact_id: Optional[StrictStr] = Field(default=None, alias="shipToContactId")
    sold_to_contact_id: Optional[StrictStr] = Field(default=None, alias="soldToContactId")
    clearing_existing_payment_term: Optional[StrictBool] = Field(default=None, alias="clearingExistingPaymentTerm")
    clearing_existing_bill_to_contact: Optional[StrictBool] = Field(default=None, alias="clearingExistingBillToContact")
    clearing_existing_invoice_group_number: Optional[StrictBool] = Field(default=None, alias="clearingExistingInvoiceGroupNumber")
    clearing_existing_invoice_template: Optional[StrictBool] = Field(default=None, alias="clearingExistingInvoiceTemplate")
    clearing_existing_sequence_set: Optional[StrictBool] = Field(default=None, alias="clearingExistingSequenceSet")
    clearing_existing_sold_to_contact: Optional[StrictBool] = Field(default=None, alias="clearingExistingSoldToContact")
    clearing_existing_ship_to_contact: Optional[StrictBool] = Field(default=None, alias="clearingExistingShipToContact")
    sub_type: Optional[StrictStr] = Field(default=None, alias="subType")
    effective_policy: Optional[StrictStr] = Field(default=None, alias="effectivePolicy")
    subscription: Optional[ExpandedSubscription] = None
    order: Optional[ExpandedOrders] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "createdById", "createdDate", "updatedById", "updatedDate", "contractEffectiveDate", "customerAcceptanceDate", "type", "sequence", "subscriptionVersionAmendmentId", "orderId", "subscriptionId", "changeReason", "subscriptionNumber", "serviceActivationDate", "autoRenew", "renewSetting", "renewalTerm", "renewalTermPeriodType", "termStartDate", "termType", "currentTerm", "currentTermPeriodType", "suspendDate", "resumeDate", "cancellationEffectiveDate", "cancellationPolicy", "paymentTerm", "billToContactId", "invoiceGroupNumber", "invoiceTemplateId", "sequenceSetId", "shipToContactId", "soldToContactId", "clearingExistingPaymentTerm", "clearingExistingBillToContact", "clearingExistingInvoiceGroupNumber", "clearingExistingInvoiceTemplate", "clearingExistingSequenceSet", "clearingExistingSoldToContact", "clearingExistingShipToContact", "subType", "effectivePolicy", "subscription", "order"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExpandedOrderAction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of subscription
        if self.subscription:
            _dict['subscription'] = self.subscription.to_dict()
        # override the default output from pydantic by calling `to_dict()` of order
        if self.order:
            _dict['order'] = self.order.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExpandedOrderAction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "id": obj.get("id"),
            "createdById": obj.get("createdById"),
            "createdDate": obj.get("createdDate"),
            "updatedById": obj.get("updatedById"),
            "updatedDate": obj.get("updatedDate"),
            "contractEffectiveDate": obj.get("contractEffectiveDate"),
            "customerAcceptanceDate": obj.get("customerAcceptanceDate"),
            "type": obj.get("type"),
            "sequence": obj.get("sequence"),
            "subscriptionVersionAmendmentId": obj.get("subscriptionVersionAmendmentId"),
            "orderId": obj.get("orderId"),
            "subscriptionId": obj.get("subscriptionId"),
            "changeReason": obj.get("changeReason"),
            "subscriptionNumber": obj.get("subscriptionNumber"),
            "serviceActivationDate": obj.get("serviceActivationDate"),
            "autoRenew": obj.get("autoRenew"),
            "renewSetting": obj.get("renewSetting"),
            "renewalTerm": obj.get("renewalTerm"),
            "renewalTermPeriodType": obj.get("renewalTermPeriodType"),
            "termStartDate": obj.get("termStartDate"),
            "termType": obj.get("termType"),
            "currentTerm": obj.get("currentTerm"),
            "currentTermPeriodType": obj.get("currentTermPeriodType"),
            "suspendDate": obj.get("suspendDate"),
            "resumeDate": obj.get("resumeDate"),
            "cancellationEffectiveDate": obj.get("cancellationEffectiveDate"),
            "cancellationPolicy": obj.get("cancellationPolicy"),
            "paymentTerm": obj.get("paymentTerm"),
            "billToContactId": obj.get("billToContactId"),
            "invoiceGroupNumber": obj.get("invoiceGroupNumber"),
            "invoiceTemplateId": obj.get("invoiceTemplateId"),
            "sequenceSetId": obj.get("sequenceSetId"),
            "shipToContactId": obj.get("shipToContactId"),
            "soldToContactId": obj.get("soldToContactId"),
            "clearingExistingPaymentTerm": obj.get("clearingExistingPaymentTerm"),
            "clearingExistingBillToContact": obj.get("clearingExistingBillToContact"),
            "clearingExistingInvoiceGroupNumber": obj.get("clearingExistingInvoiceGroupNumber"),
            "clearingExistingInvoiceTemplate": obj.get("clearingExistingInvoiceTemplate"),
            "clearingExistingSequenceSet": obj.get("clearingExistingSequenceSet"),
            "clearingExistingSoldToContact": obj.get("clearingExistingSoldToContact"),
            "clearingExistingShipToContact": obj.get("clearingExistingShipToContact"),
            "subType": obj.get("subType"),
            "effectivePolicy": obj.get("effectivePolicy"),
            "subscription": ExpandedSubscription.from_dict(obj["subscription"]) if obj.get("subscription") is not None else None,
            "order": ExpandedOrders.from_dict(obj["order"]) if obj.get("order") is not None else None
        }
        return _obj
from zuora_sdk.models.expanded_orders import ExpandedOrders
from zuora_sdk.models.expanded_subscription import ExpandedSubscription
# TODO: Rewrite to not use raise_errors
ExpandedOrderAction.model_rebuild(raise_errors=False)


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
