# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from zuora_sdk.models.expanded_account import ExpandedAccount
from zuora_sdk.models.expanded_prepaid_balance import ExpandedPrepaidBalance
from zuora_sdk.models.expanded_rate_plan_charge import ExpandedRatePlanCharge
from zuora_sdk.models.expanded_validity_period_summary import ExpandedValidityPeriodSummary
from typing import Optional, Set
from typing_extensions import Self

class ExpandedPrepaidBalanceFund(BaseModel):
    """
    ExpandedPrepaidBalanceFund
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    id: Optional[StrictStr] = None
    created_by_id: Optional[StrictStr] = Field(default=None, alias="createdById")
    created_date: Optional[StrictStr] = Field(default=None, alias="createdDate")
    updated_by_id: Optional[StrictStr] = Field(default=None, alias="updatedById")
    updated_date: Optional[StrictStr] = Field(default=None, alias="updatedDate")
    account_id: Optional[StrictStr] = Field(default=None, alias="accountId")
    balance: Optional[Union[StrictFloat, StrictInt]] = None
    charge_segment_number: Optional[StrictInt] = Field(default=None, alias="chargeSegmentNumber")
    end_date: Optional[date] = Field(default=None, alias="endDate")
    funded_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="fundedBalance")
    fund_source_type: Optional[StrictStr] = Field(default=None, alias="fundSourceType")
    funding_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="fundingPrice")
    total_billed: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="totalBilled")
    total_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="totalBalance")
    original_total_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="originalTotalBalance")
    original_funding_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="originalFundingPrice")
    original_fund_end_date: Optional[date] = Field(default=None, alias="originalFundEndDate")
    rollover_validity_period_start_date: Optional[date] = Field(default=None, alias="rolloverValidityPeriodStartDate")
    rollover_validity_period_end_date: Optional[date] = Field(default=None, alias="rolloverValidityPeriodEndDate")
    prepaid_balance_id: Optional[StrictStr] = Field(default=None, alias="prepaidBalanceId")
    priority: Optional[StrictInt] = None
    source_id: Optional[StrictStr] = Field(default=None, alias="sourceId")
    start_date: Optional[date] = Field(default=None, alias="startDate")
    vp_summary_id: Optional[StrictStr] = Field(default=None, alias="vpSummaryId")
    rollover_count: Optional[StrictInt] = Field(default=None, alias="rolloverCount")
    origin_fund_id: Optional[StrictStr] = Field(default=None, alias="originFundId")
    rollover_apply_option: Optional[StrictStr] = Field(default=None, alias="rolloverApplyOption")
    done: Optional[StrictInt] = None
    account: Optional[ExpandedAccount] = None
    prepaid_balance: Optional[ExpandedPrepaidBalance] = Field(default=None, alias="prepaidBalance")
    source: Optional[ExpandedRatePlanCharge] = None
    vp_summary: Optional[ExpandedValidityPeriodSummary] = Field(default=None, alias="vpSummary")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "createdById", "createdDate", "updatedById", "updatedDate", "accountId", "balance", "chargeSegmentNumber", "endDate", "fundedBalance", "fundSourceType", "fundingPrice", "totalBilled", "totalBalance", "originalTotalBalance", "originalFundingPrice", "originalFundEndDate", "rolloverValidityPeriodStartDate", "rolloverValidityPeriodEndDate", "prepaidBalanceId", "priority", "sourceId", "startDate", "vpSummaryId", "rolloverCount", "originFundId", "rolloverApplyOption", "done", "account", "prepaidBalance", "source", "vpSummary"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExpandedPrepaidBalanceFund from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of account
        if self.account:
            _dict['account'] = self.account.to_dict()
        # override the default output from pydantic by calling `to_dict()` of prepaid_balance
        if self.prepaid_balance:
            _dict['prepaidBalance'] = self.prepaid_balance.to_dict()
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of vp_summary
        if self.vp_summary:
            _dict['vpSummary'] = self.vp_summary.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExpandedPrepaidBalanceFund from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "id": obj.get("id"),
            "createdById": obj.get("createdById"),
            "createdDate": obj.get("createdDate"),
            "updatedById": obj.get("updatedById"),
            "updatedDate": obj.get("updatedDate"),
            "accountId": obj.get("accountId"),
            "balance": obj.get("balance"),
            "chargeSegmentNumber": obj.get("chargeSegmentNumber"),
            "endDate": obj.get("endDate"),
            "fundedBalance": obj.get("fundedBalance"),
            "fundSourceType": obj.get("fundSourceType"),
            "fundingPrice": obj.get("fundingPrice"),
            "totalBilled": obj.get("totalBilled"),
            "totalBalance": obj.get("totalBalance"),
            "originalTotalBalance": obj.get("originalTotalBalance"),
            "originalFundingPrice": obj.get("originalFundingPrice"),
            "originalFundEndDate": obj.get("originalFundEndDate"),
            "rolloverValidityPeriodStartDate": obj.get("rolloverValidityPeriodStartDate"),
            "rolloverValidityPeriodEndDate": obj.get("rolloverValidityPeriodEndDate"),
            "prepaidBalanceId": obj.get("prepaidBalanceId"),
            "priority": obj.get("priority"),
            "sourceId": obj.get("sourceId"),
            "startDate": obj.get("startDate"),
            "vpSummaryId": obj.get("vpSummaryId"),
            "rolloverCount": obj.get("rolloverCount"),
            "originFundId": obj.get("originFundId"),
            "rolloverApplyOption": obj.get("rolloverApplyOption"),
            "done": obj.get("done"),
            "account": ExpandedAccount.from_dict(obj["account"]) if obj.get("account") is not None else None,
            "prepaidBalance": ExpandedPrepaidBalance.from_dict(obj["prepaidBalance"]) if obj.get("prepaidBalance") is not None else None,
            "source": ExpandedRatePlanCharge.from_dict(obj["source"]) if obj.get("source") is not None else None,
            "vpSummary": ExpandedValidityPeriodSummary.from_dict(obj["vpSummary"]) if obj.get("vpSummary") is not None else None
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
