# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class ExpandedRatingDetail(BaseModel):
    """
    ExpandedRatingDetail
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    id: Optional[StrictStr] = None
    charge_type: Optional[StrictStr] = Field(default=None, alias="chargeType")
    charge_model: Optional[StrictStr] = Field(default=None, alias="chargeModel")
    formula: Optional[StrictStr] = None
    calculation: Optional[StrictStr] = None
    calculated_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="calculatedAmount")
    currency: Optional[StrictStr] = None
    unit_of_measure: Optional[StrictStr] = Field(default=None, alias="unitOfMeasure")
    billed_quantity: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="billedQuantity")
    billed_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="billedAmount")
    quantity: Optional[Union[StrictFloat, StrictInt]] = None
    is_proration: Optional[StrictBool] = Field(default=None, alias="isProration")
    is_credit: Optional[StrictBool] = Field(default=None, alias="isCredit")
    list_price_base: Optional[StrictStr] = Field(default=None, alias="listPriceBase")
    billing_cycle_day: Optional[StrictInt] = Field(default=None, alias="billingCycleDay")
    billing_cycle_type: Optional[StrictStr] = Field(default=None, alias="billingCycleType")
    billing_period: Optional[StrictStr] = Field(default=None, alias="billingPeriod")
    specific_billing_period: Optional[StrictStr] = Field(default=None, alias="specificBillingPeriod")
    validity_period_type: Optional[StrictStr] = Field(default=None, alias="validityPeriodType")
    billing_period_alignment: Optional[StrictStr] = Field(default=None, alias="billingPeriodAlignment")
    alignment_start_date: Optional[date] = Field(default=None, alias="alignmentStartDate")
    amount_without_tax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="amountWithoutTax")
    is_inclusive_tax_no_rounding: Optional[StrictBool] = Field(default=None, alias="isInclusiveTaxNoRounding")
    is_proration_partial_period: Optional[StrictBool] = Field(default=None, alias="isProrationPartialPeriod")
    is_prorate_monthly_charges: Optional[StrictBool] = Field(default=None, alias="isProrateMonthlyCharges")
    is_prorate_weekly_charges: Optional[StrictBool] = Field(default=None, alias="isProrateWeeklyCharges")
    proration_unit_rule: Optional[StrictStr] = Field(default=None, alias="prorationUnitRule")
    days_in_month_rule: Optional[StrictStr] = Field(default=None, alias="daysInMonthRule")
    recurring_credit_proration_option_rule: Optional[StrictStr] = Field(default=None, alias="recurringCreditProrationOptionRule")
    is_credit_with_original_ce: Optional[StrictBool] = Field(default=None, alias="isCreditWithOriginalCE")
    is_prorate_discount_credit: Optional[StrictBool] = Field(default=None, alias="isProrateDiscountCredit")
    stacked_discount_class_apply_rule: Optional[StrictStr] = Field(default=None, alias="stackedDiscountClassApplyRule")
    recurring_period_start: Optional[date] = Field(default=None, alias="recurringPeriodStart")
    recurring_period_end: Optional[date] = Field(default=None, alias="recurringPeriodEnd")
    charge_start_date: Optional[date] = Field(default=None, alias="chargeStartDate")
    charge_end_date: Optional[date] = Field(default=None, alias="chargeEndDate")
    sub_start_date: Optional[date] = Field(default=None, alias="subStartDate")
    sub_end_date: Optional[date] = Field(default=None, alias="subEndDate")
    term_start_date: Optional[date] = Field(default=None, alias="termStartDate")
    term_end_date: Optional[date] = Field(default=None, alias="termEndDate")
    credit_option: Optional[StrictStr] = Field(default=None, alias="creditOption")
    funding_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="fundingPrice")
    total_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="totalBalance")
    remaining_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="remainingBalance")
    original_billing_period_start: Optional[date] = Field(default=None, alias="originalBillingPeriodStart")
    original_billing_period_end: Optional[date] = Field(default=None, alias="originalBillingPeriodEnd")
    original_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="originalAmount")
    base_price: Optional[StrictStr] = Field(default=None, alias="basePrice")
    discount_class: Optional[StrictStr] = Field(default=None, alias="discountClass")
    discount_class_order: Optional[StrictInt] = Field(default=None, alias="discountClassOrder")
    discount_level: Optional[StrictStr] = Field(default=None, alias="discountLevel")
    discount_apply_sequence: Optional[StrictInt] = Field(default=None, alias="discountApplySequence")
    discount_schedule_period_start: Optional[date] = Field(default=None, alias="discountSchedulePeriodStart")
    discount_schedule_period_end: Optional[date] = Field(default=None, alias="discountSchedulePeriodEnd")
    regular_charge_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="regularChargeAmount")
    regular_charge_amount_left: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="regularChargeAmountLeft")
    original_regular_charge_amount: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="originalRegularChargeAmount")
    discount_balance_formula: Optional[StrictStr] = Field(default=None, alias="discountBalanceFormula")
    invoice_item_id: Optional[StrictStr] = Field(default=None, alias="invoiceItemId")
    credit_memo_item_id: Optional[StrictStr] = Field(default=None, alias="creditMemoItemId")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "chargeType", "chargeModel", "formula", "calculation", "calculatedAmount", "currency", "unitOfMeasure", "billedQuantity", "billedAmount", "quantity", "isProration", "isCredit", "listPriceBase", "billingCycleDay", "billingCycleType", "billingPeriod", "specificBillingPeriod", "validityPeriodType", "billingPeriodAlignment", "alignmentStartDate", "amountWithoutTax", "isInclusiveTaxNoRounding", "isProrationPartialPeriod", "isProrateMonthlyCharges", "isProrateWeeklyCharges", "prorationUnitRule", "daysInMonthRule", "recurringCreditProrationOptionRule", "isCreditWithOriginalCE", "isProrateDiscountCredit", "stackedDiscountClassApplyRule", "recurringPeriodStart", "recurringPeriodEnd", "chargeStartDate", "chargeEndDate", "subStartDate", "subEndDate", "termStartDate", "termEndDate", "creditOption", "fundingPrice", "totalBalance", "remainingBalance", "originalBillingPeriodStart", "originalBillingPeriodEnd", "originalAmount", "basePrice", "discountClass", "discountClassOrder", "discountLevel", "discountApplySequence", "discountSchedulePeriodStart", "discountSchedulePeriodEnd", "regularChargeAmount", "regularChargeAmountLeft", "originalRegularChargeAmount", "discountBalanceFormula", "invoiceItemId", "creditMemoItemId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExpandedRatingDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExpandedRatingDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "id": obj.get("id"),
            "chargeType": obj.get("chargeType"),
            "chargeModel": obj.get("chargeModel"),
            "formula": obj.get("formula"),
            "calculation": obj.get("calculation"),
            "calculatedAmount": obj.get("calculatedAmount"),
            "currency": obj.get("currency"),
            "unitOfMeasure": obj.get("unitOfMeasure"),
            "billedQuantity": obj.get("billedQuantity"),
            "billedAmount": obj.get("billedAmount"),
            "quantity": obj.get("quantity"),
            "isProration": obj.get("isProration"),
            "isCredit": obj.get("isCredit"),
            "listPriceBase": obj.get("listPriceBase"),
            "billingCycleDay": obj.get("billingCycleDay"),
            "billingCycleType": obj.get("billingCycleType"),
            "billingPeriod": obj.get("billingPeriod"),
            "specificBillingPeriod": obj.get("specificBillingPeriod"),
            "validityPeriodType": obj.get("validityPeriodType"),
            "billingPeriodAlignment": obj.get("billingPeriodAlignment"),
            "alignmentStartDate": obj.get("alignmentStartDate"),
            "amountWithoutTax": obj.get("amountWithoutTax"),
            "isInclusiveTaxNoRounding": obj.get("isInclusiveTaxNoRounding"),
            "isProrationPartialPeriod": obj.get("isProrationPartialPeriod"),
            "isProrateMonthlyCharges": obj.get("isProrateMonthlyCharges"),
            "isProrateWeeklyCharges": obj.get("isProrateWeeklyCharges"),
            "prorationUnitRule": obj.get("prorationUnitRule"),
            "daysInMonthRule": obj.get("daysInMonthRule"),
            "recurringCreditProrationOptionRule": obj.get("recurringCreditProrationOptionRule"),
            "isCreditWithOriginalCE": obj.get("isCreditWithOriginalCE"),
            "isProrateDiscountCredit": obj.get("isProrateDiscountCredit"),
            "stackedDiscountClassApplyRule": obj.get("stackedDiscountClassApplyRule"),
            "recurringPeriodStart": obj.get("recurringPeriodStart"),
            "recurringPeriodEnd": obj.get("recurringPeriodEnd"),
            "chargeStartDate": obj.get("chargeStartDate"),
            "chargeEndDate": obj.get("chargeEndDate"),
            "subStartDate": obj.get("subStartDate"),
            "subEndDate": obj.get("subEndDate"),
            "termStartDate": obj.get("termStartDate"),
            "termEndDate": obj.get("termEndDate"),
            "creditOption": obj.get("creditOption"),
            "fundingPrice": obj.get("fundingPrice"),
            "totalBalance": obj.get("totalBalance"),
            "remainingBalance": obj.get("remainingBalance"),
            "originalBillingPeriodStart": obj.get("originalBillingPeriodStart"),
            "originalBillingPeriodEnd": obj.get("originalBillingPeriodEnd"),
            "originalAmount": obj.get("originalAmount"),
            "basePrice": obj.get("basePrice"),
            "discountClass": obj.get("discountClass"),
            "discountClassOrder": obj.get("discountClassOrder"),
            "discountLevel": obj.get("discountLevel"),
            "discountApplySequence": obj.get("discountApplySequence"),
            "discountSchedulePeriodStart": obj.get("discountSchedulePeriodStart"),
            "discountSchedulePeriodEnd": obj.get("discountSchedulePeriodEnd"),
            "regularChargeAmount": obj.get("regularChargeAmount"),
            "regularChargeAmountLeft": obj.get("regularChargeAmountLeft"),
            "originalRegularChargeAmount": obj.get("originalRegularChargeAmount"),
            "discountBalanceFormula": obj.get("discountBalanceFormula"),
            "invoiceItemId": obj.get("invoiceItemId"),
            "creditMemoItemId": obj.get("creditMemoItemId")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
