# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class FulfillmentState(str, Enum):
    """
    The state of the Fulfillment. See [State transitions for an order, order line item, and fulfillment](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AB_Order_Line_Item_States_and_Order_States) for more information. 
    """

    """
    allowed enum values
    """
    EXECUTING = 'Executing'
    BOOKED = 'Booked'
    SENTTOBILLING = 'SentToBilling'
    COMPLETE = 'Complete'
    CANCELLED = 'Cancelled'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FulfillmentState from a JSON string"""
        return cls(json.loads(json_str))


