# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class GetWorkflowResponseStatus(str, Enum):
    """
    The status of the workflow:   - Queued: The workflow is in queue for being processed.   - Processing: The workflow is in process.   - Stopping: The workflow is being stopped through Zuora UI.   - Stopped: The workflow is stopped through Zuora UI.   - Finished: The workflow is finished. When a workflow is finished, it might have tasks pending for retry or delay. Pending tasks do not block the onfinish branch of the workflow, but they block the oncomplete branch of the iterate.  
    """

    """
    allowed enum values
    """
    QUEUED = 'Queued'
    PROCESSING = 'Processing'
    STOPPING = 'Stopping'
    STOPPED = 'Stopped'
    FINISHED = 'Finished'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of GetWorkflowResponseStatus from a JSON string"""
        return cls(json.loads(json_str))


