# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.data_backfill_job_status import DataBackfillJobStatus
from zuora_sdk.models.job_type import JobType
from typing import Optional, Set
from typing_extensions import Self

class Job(BaseModel):
    """
    Job
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    id: Optional[StrictStr] = Field(default=None, description="Job id")
    import_type: Optional[JobType] = Field(default=None, alias="importType")
    uploaded_file_id: Optional[StrictStr] = Field(default=None, description="Id of uploaded file", alias="uploadedFileId")
    uploaded_file_name: Optional[StrictStr] = Field(default=None, description="Name of uploaded file", alias="uploadedFileName")
    uploaded_file_url: Optional[StrictStr] = Field(default=None, alias="uploadedFileUrl")
    uploaded_file_size: Optional[StrictStr] = Field(default=None, alias="uploadedFileSize")
    input_file_size: Optional[StrictInt] = Field(default=None, alias="inputFileSize")
    output_size: Optional[StrictStr] = Field(default=None, alias="outputSize")
    output_type: Optional[StrictStr] = Field(default=None, alias="outputType")
    output_file_size: Optional[StrictInt] = Field(default=None, alias="outputFileSize")
    uploaded_by: Optional[StrictStr] = Field(default=None, alias="uploadedBy")
    uploaded_on: Optional[datetime] = Field(default=None, alias="uploadedOn")
    completed_on: Optional[datetime] = Field(default=None, alias="completedOn")
    started_processing_on: Optional[datetime] = Field(default=None, alias="startedProcessingOn")
    result_file_id: Optional[StrictStr] = Field(default=None, alias="resultFileId")
    result_file_name: Optional[StrictStr] = Field(default=None, alias="resultFileName")
    result_file_url: Optional[StrictStr] = Field(default=None, alias="resultFileUrl")
    total_count: Optional[StrictInt] = Field(default=None, alias="totalCount")
    failed_count: Optional[StrictInt] = Field(default=None, alias="failedCount")
    status: Optional[DataBackfillJobStatus] = None
    failure_message: Optional[StrictStr] = Field(default=None, alias="failureMessage")
    processed_count: Optional[StrictInt] = Field(default=None, alias="processedCount")
    success_count: Optional[StrictInt] = Field(default=None, alias="successCount")
    remaining_time: Optional[StrictInt] = Field(default=None, alias="remainingTime")
    remaining_time_text: Optional[StrictStr] = Field(default=None, alias="remainingTimeText")
    completed_percentage: Optional[StrictInt] = Field(default=None, alias="completedPercentage")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "importType", "uploadedFileId", "uploadedFileName", "uploadedFileUrl", "uploadedFileSize", "inputFileSize", "outputSize", "outputType", "outputFileSize", "uploadedBy", "uploadedOn", "completedOn", "startedProcessingOn", "resultFileId", "resultFileName", "resultFileUrl", "totalCount", "failedCount", "status", "failureMessage", "processedCount", "successCount", "remainingTime", "remainingTimeText", "completedPercentage"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Job from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Job from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "id": obj.get("id"),
            "importType": obj.get("importType"),
            "uploadedFileId": obj.get("uploadedFileId"),
            "uploadedFileName": obj.get("uploadedFileName"),
            "uploadedFileUrl": obj.get("uploadedFileUrl"),
            "uploadedFileSize": obj.get("uploadedFileSize"),
            "inputFileSize": obj.get("inputFileSize"),
            "outputSize": obj.get("outputSize"),
            "outputType": obj.get("outputType"),
            "outputFileSize": obj.get("outputFileSize"),
            "uploadedBy": obj.get("uploadedBy"),
            "uploadedOn": obj.get("uploadedOn"),
            "completedOn": obj.get("completedOn"),
            "startedProcessingOn": obj.get("startedProcessingOn"),
            "resultFileId": obj.get("resultFileId"),
            "resultFileName": obj.get("resultFileName"),
            "resultFileUrl": obj.get("resultFileUrl"),
            "totalCount": obj.get("totalCount"),
            "failedCount": obj.get("failedCount"),
            "status": obj.get("status"),
            "failureMessage": obj.get("failureMessage"),
            "processedCount": obj.get("processedCount"),
            "successCount": obj.get("successCount"),
            "remainingTime": obj.get("remainingTime"),
            "remainingTimeText": obj.get("remainingTimeText"),
            "completedPercentage": obj.get("completedPercentage")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
