# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PaymentTransactionLogResponse(BaseModel):
    """
    PaymentTransactionLogResponse
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    avs_response_code: Optional[StrictStr] = Field(default=None, description="The response code returned by the payment gateway referring to the AVS international response of the payment transaction. ", alias="AVSResponseCode")
    batch_id: Optional[StrictStr] = Field(default=None, description="The ID of the batch used to send the transaction if the request was sent in a batch. ", alias="BatchId")
    cvv_response_code: Optional[StrictStr] = Field(default=None, description="The response code returned by the payment gateway referring to the CVV international response of the payment transaction. ", alias="CVVResponseCode")
    gateway: Optional[StrictStr] = Field(default=None, description="The name of the payment gateway used to transact the current payment transaction log. ", alias="Gateway")
    gateway_reason_code: Optional[StrictStr] = Field(default=None, description="The code returned by the payment gateway for the payment. This code is gateway-dependent. ", alias="GatewayReasonCode")
    gateway_reason_code_description: Optional[StrictStr] = Field(default=None, description="The message returned by the payment gateway for the payment. This message is gateway-dependent.  ", alias="GatewayReasonCodeDescription")
    gateway_state: Optional[StrictStr] = Field(default=None, alias="GatewayState")
    gateway_transaction_type: Optional[StrictStr] = Field(default=None, alias="GatewayTransactionType")
    id: Optional[StrictStr] = Field(default=None, description="The ID of the payment transaction log. ", alias="Id")
    payment_id: Optional[StrictStr] = Field(default=None, description="The ID of the payment wherein the payment transaction log was recorded.  ", alias="PaymentId")
    request_string: Optional[StrictStr] = Field(default=None, description="The payment transaction request string sent to the payment gateway.  ", alias="RequestString")
    response_string: Optional[StrictStr] = Field(default=None, description="The payment transaction response string returned by the payment gateway.  ", alias="ResponseString")
    transaction_date: Optional[datetime] = Field(default=None, description="The transaction date when the payment was performed.  ", alias="TransactionDate")
    transaction_id: Optional[StrictStr] = Field(default=None, description="The transaction ID returned by the payment gateway. This field is used to reconcile payment transactions between the payment gateway and records in Zuora. ", alias="TransactionId")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["AVSResponseCode", "BatchId", "CVVResponseCode", "Gateway", "GatewayReasonCode", "GatewayReasonCodeDescription", "GatewayState", "GatewayTransactionType", "Id", "PaymentId", "RequestString", "ResponseString", "TransactionDate", "TransactionId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentTransactionLogResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentTransactionLogResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "AVSResponseCode": obj.get("AVSResponseCode"),
            "BatchId": obj.get("BatchId"),
            "CVVResponseCode": obj.get("CVVResponseCode"),
            "Gateway": obj.get("Gateway"),
            "GatewayReasonCode": obj.get("GatewayReasonCode"),
            "GatewayReasonCodeDescription": obj.get("GatewayReasonCodeDescription"),
            "GatewayState": obj.get("GatewayState"),
            "GatewayTransactionType": obj.get("GatewayTransactionType"),
            "Id": obj.get("Id"),
            "PaymentId": obj.get("PaymentId"),
            "RequestString": obj.get("RequestString"),
            "ResponseString": obj.get("ResponseString"),
            "TransactionDate": obj.get("TransactionDate"),
            "TransactionId": obj.get("TransactionId")
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
