# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.order_delta_mrr import OrderDeltaMrr
from zuora_sdk.models.order_delta_qty import OrderDeltaQty
from zuora_sdk.models.order_delta_tcb import OrderDeltaTcb
from zuora_sdk.models.order_delta_tcv import OrderDeltaTcv
from typing import Optional, Set
from typing_extensions import Self

class PreviewOrderResultDeltaMetrics(BaseModel):
    """
    **Note:** As of Zuora Billing Release 306, Zuora has upgraded the methodologies for calculating metrics in [Orders](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders). The new methodologies are reflected in the following Order Delta Metrics objects.  * [Order Delta Mrr](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Delta_Metrics/Order_Delta_Mrr) * [Order Delta Tcv](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Delta_Metrics/Order_Delta_Tcv) * [Order Delta Tcb](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Delta_Metrics/Order_Delta_Tcb)  It is recommended that all customers use the new [Order Delta Metrics](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Delta_Metrics/AA_Overview_of_Order_Delta_Metrics). If you are an existing [Order Metrics](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/AA_Overview_of_Orders/Key_Metrics_for_Orders) customer and want to migrate to Order Delta Metrics, submit a request at [Zuora Global Support](https://support.zuora.com/). 
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    order_delta_mrr: Optional[List[OrderDeltaMrr]] = Field(default=None, alias="orderDeltaMrr")
    order_delta_tcb: Optional[List[OrderDeltaTcb]] = Field(default=None, alias="orderDeltaTcb")
    order_delta_tcv: Optional[List[OrderDeltaTcv]] = Field(default=None, alias="orderDeltaTcv")
    order_delta_qty: Optional[List[OrderDeltaQty]] = Field(default=None, alias="orderDeltaQty")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["orderDeltaMrr", "orderDeltaTcb", "orderDeltaTcv", "orderDeltaQty"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PreviewOrderResultDeltaMetrics from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in order_delta_mrr (list)
        _items = []
        if self.order_delta_mrr:
            for _item_order_delta_mrr in self.order_delta_mrr:
                if _item_order_delta_mrr:
                    _items.append(_item_order_delta_mrr.to_dict())
            _dict['orderDeltaMrr'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in order_delta_tcb (list)
        _items = []
        if self.order_delta_tcb:
            for _item_order_delta_tcb in self.order_delta_tcb:
                if _item_order_delta_tcb:
                    _items.append(_item_order_delta_tcb.to_dict())
            _dict['orderDeltaTcb'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in order_delta_tcv (list)
        _items = []
        if self.order_delta_tcv:
            for _item_order_delta_tcv in self.order_delta_tcv:
                if _item_order_delta_tcv:
                    _items.append(_item_order_delta_tcv.to_dict())
            _dict['orderDeltaTcv'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in order_delta_qty (list)
        _items = []
        if self.order_delta_qty:
            for _item_order_delta_qty in self.order_delta_qty:
                if _item_order_delta_qty:
                    _items.append(_item_order_delta_qty.to_dict())
            _dict['orderDeltaQty'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PreviewOrderResultDeltaMetrics from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "orderDeltaMrr": [OrderDeltaMrr.from_dict(_item) for _item in obj["orderDeltaMrr"]] if obj.get("orderDeltaMrr") is not None else None,
            "orderDeltaTcb": [OrderDeltaTcb.from_dict(_item) for _item in obj["orderDeltaTcb"]] if obj.get("orderDeltaTcb") is not None else None,
            "orderDeltaTcv": [OrderDeltaTcv.from_dict(_item) for _item in obj["orderDeltaTcv"]] if obj.get("orderDeltaTcv") is not None else None,
            "orderDeltaQty": [OrderDeltaQty.from_dict(_item) for _item in obj["orderDeltaQty"]] if obj.get("orderDeltaQty") is not None else None
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
