# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class PreviewThruDatePolicy(str, Enum):
    """
    The options on how the preview through date is calculated.  - If you set this field to `nextBillingPeriods`, you must specify the number of billing periods to preview in the `nextBillingPeriods` field. - If you set this field to `endOfTerm`, the preview through date is the end date of the subscription term. - If you set this field to `specificDate`, you must specify a specific date in the `specificDate` field. The date must be in the format `yyyy-mm-dd`. 
    """

    """
    allowed enum values
    """
    NEXTBILLINGPERIODS = 'nextBillingPeriods'
    ENDOFTERM = 'endOfTerm'
    SPECIFICDATE = 'specificDate'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PreviewThruDatePolicy from a JSON string"""
        return cls(json.loads(json_str))


