# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ProrationOption(str, Enum):
    """
    **Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. To use this field, you must set the `X-Zuora-WSDL-Version` request header to 135 or higher. Otherwise, an error occurs. This field defines the proration options for a usage charge or recurring charge. 
    """

    """
    allowed enum values
    """
    NOPRORATION = 'NoProration'
    TIMEBASEDPRORATION = 'TimeBasedProration'
    DEFAULTFROMTENANTSETTING = 'DefaultFromTenantSetting'
    CHARGEFULLPERIOD = 'ChargeFullPeriod'
    CUSTOMIZEPRORATIONOPTIONOVERRIDES = 'CustomizeProrationOptionOverrides'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ProrationOption from a JSON string"""
        return cls(json.loads(json_str))


