# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.retrieve_deployment_response_failed_inner import RetrieveDeploymentResponseFailedInner
from zuora_sdk.models.retrieve_deployment_response_skipped_inner import RetrieveDeploymentResponseSkippedInner
from zuora_sdk.models.retrieve_deployment_response_succeeded_inner import RetrieveDeploymentResponseSucceededInner
from zuora_sdk.models.retrieve_deployment_response_target_tenant import RetrieveDeploymentResponseTargetTenant
from typing import Optional, Set
from typing_extensions import Self

class RetrieveDeploymentResponse(BaseModel):
    """
    Response when deployment is retrieved.
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    id: Optional[StrictStr] = Field(default=None, description="ID of the Deployment Manager migration process.")
    status: Optional[StrictStr] = Field(default=None, description="Status of the Deployment Manager migration.")
    name: Optional[StrictStr] = Field(default=None, description="Name of the migration.")
    description: Optional[StrictStr] = Field(default=None, description="Description of the migration.")
    run_by: Optional[StrictStr] = Field(default=None, description="Name of the user who executed the migration.", alias="runBy")
    start_time: Optional[StrictStr] = Field(default=None, description="Deployment timestamp.", alias="startTime")
    target_tenant: Optional[RetrieveDeploymentResponseTargetTenant] = Field(default=None, alias="targetTenant")
    succeeded: Optional[List[RetrieveDeploymentResponseSucceededInner]] = Field(default=None, description="List of succeeded components.")
    failed: Optional[List[RetrieveDeploymentResponseFailedInner]] = Field(default=None, description="List of failed components.")
    skipped: Optional[List[RetrieveDeploymentResponseSkippedInner]] = Field(default=None, description="List of skipped components.")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["id", "status", "name", "description", "runBy", "startTime", "targetTenant", "succeeded", "failed", "skipped"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RetrieveDeploymentResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of target_tenant
        if self.target_tenant:
            _dict['targetTenant'] = self.target_tenant.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in succeeded (list)
        _items = []
        if self.succeeded:
            for _item_succeeded in self.succeeded:
                if _item_succeeded:
                    _items.append(_item_succeeded.to_dict())
            _dict['succeeded'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in failed (list)
        _items = []
        if self.failed:
            for _item_failed in self.failed:
                if _item_failed:
                    _items.append(_item_failed.to_dict())
            _dict['failed'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in skipped (list)
        _items = []
        if self.skipped:
            for _item_skipped in self.skipped:
                if _item_skipped:
                    _items.append(_item_skipped.to_dict())
            _dict['skipped'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RetrieveDeploymentResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "id": obj.get("id"),
            "status": obj.get("status"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "runBy": obj.get("runBy"),
            "startTime": obj.get("startTime"),
            "targetTenant": RetrieveDeploymentResponseTargetTenant.from_dict(obj["targetTenant"]) if obj.get("targetTenant") is not None else None,
            "succeeded": [RetrieveDeploymentResponseSucceededInner.from_dict(_item) for _item in obj["succeeded"]] if obj.get("succeeded") is not None else None,
            "failed": [RetrieveDeploymentResponseFailedInner.from_dict(_item) for _item in obj["failed"]] if obj.get("failed") is not None else None,
            "skipped": [RetrieveDeploymentResponseSkippedInner.from_dict(_item) for _item in obj["skipped"]] if obj.get("skipped") is not None else None
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
