# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from zuora_sdk.models.change_log_field import ChangeLogField
from zuora_sdk.models.rate_plan_change_log import RatePlanChangeLog
from typing import Optional, Set
from typing_extensions import Self

class SubscriptionChangeLog(BaseModel):
    """
    Represents the order information that will be returned in the GET call.
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

        _dict_all = convert_snake_dict_to_camel(kwargs, self.model_fields, self.__properties)

        _dict = self.to_alias_dict(_dict_all)
        for field_name, field_info in self.model_fields.items():
            alias = field_info.alias or field_name
            if alias in _dict:
                self.__dict__[field_name] = _dict.get(alias)
        self.update_additional_properties(self, _dict_all)
        pass

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    subscription_number: Optional[StrictStr] = Field(default=None, description="Subscription number.", alias="subscriptionNumber")
    account_number: Optional[StrictStr] = Field(default=None, description="Account number.", alias="accountNumber")
    invoice_owner_account_number: Optional[StrictStr] = Field(default=None, description="Invoice owner account number of the subscription.", alias="invoiceOwnerAccountNumber")
    currency: Optional[StrictStr] = Field(default=None, description="The currency of the subscription.")
    order_number: Optional[StrictStr] = Field(default=None, description="The order number of the order which created this subscription.", alias="orderNumber")
    version: Optional[StrictStr] = Field(default=None, description="The version of the subscription.")
    changed_time: Optional[StrictStr] = Field(default=None, description="The create time of the subscription.", alias="changedTime")
    type: Optional[StrictStr] = Field(default=None, description="The type of the subscription.")
    external_subscription_id: Optional[StrictStr] = Field(default=None, description="External subscription id.", alias="externalSubscriptionId")
    subscription_start_date: Optional[StrictStr] = Field(default=None, description="Start date of the subscription.", alias="subscriptionStartDate")
    subscription_end_date: Optional[StrictStr] = Field(default=None, description="End date of the subscription.", alias="subscriptionEndDate")
    term_start_date: Optional[StrictStr] = Field(default=None, description="Term start date of the subscription.", alias="termStartDate")
    term_end_date: Optional[StrictStr] = Field(default=None, description="Term end date of the subscription.", alias="termEndDate")
    rate_plans: Optional[List[RatePlanChangeLog]] = Field(default=None, description="Represents the rate plans in this subscription.", alias="ratePlans")
    fields: Optional[List[ChangeLogField]] = Field(default=None, description="Represents the fields which the value is changed for this charge.")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["subscriptionNumber", "accountNumber", "invoiceOwnerAccountNumber", "currency", "orderNumber", "version", "changedTime", "type", "externalSubscriptionId", "subscriptionStartDate", "subscriptionEndDate", "termStartDate", "termEndDate", "ratePlans", "fields"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SubscriptionChangeLog from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rate_plans (list)
        _items = []
        if self.rate_plans:
            for _item_rate_plans in self.rate_plans:
                if _item_rate_plans:
                    _items.append(_item_rate_plans.to_dict())
            _dict['ratePlans'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in fields (list)
        _items = []
        if self.fields:
            for _item_fields in self.fields:
                if _item_fields:
                    _items.append(_item_fields.to_dict())
            _dict['fields'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SubscriptionChangeLog from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        obj = convert_snake_dict_to_camel(obj, cls.model_fields, cls.__properties)

        _obj = cls.model_validate(cls.to_alias_dict(obj))
        return cls.update_additional_properties(_obj, obj)

    @classmethod
    def update_additional_properties(cls, obj, _dict: Optional[Dict[str, Any]]):
        # store additional fields in additional_properties

        # store additional fields in additional_properties
        for _key in _dict.keys():
            if _key not in cls.__properties:
                obj.additional_properties[_key] = _dict.get(_key)


        return obj
        pass

    @classmethod
    def to_alias_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Dict[str, Any]]:

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        return {
            "subscriptionNumber": obj.get("subscriptionNumber"),
            "accountNumber": obj.get("accountNumber"),
            "invoiceOwnerAccountNumber": obj.get("invoiceOwnerAccountNumber"),
            "currency": obj.get("currency"),
            "orderNumber": obj.get("orderNumber"),
            "version": obj.get("version"),
            "changedTime": obj.get("changedTime"),
            "type": obj.get("type"),
            "externalSubscriptionId": obj.get("externalSubscriptionId"),
            "subscriptionStartDate": obj.get("subscriptionStartDate"),
            "subscriptionEndDate": obj.get("subscriptionEndDate"),
            "termStartDate": obj.get("termStartDate"),
            "termEndDate": obj.get("termEndDate"),
            "ratePlans": [RatePlanChangeLog.from_dict(_item) for _item in obj["ratePlans"]] if obj.get("ratePlans") is not None else None,
            "fields": [ChangeLogField.from_dict(_item) for _item in obj["fields"]] if obj.get("fields") is not None else None
        }
        return _obj


def convert_snake_dict_to_camel(_dict: dict, model_fields, properties):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        if k in model_fields:
            # model_fields: key is attribute name like bill_to_contact,
            alias = model_fields.get(k).alias or k
            new_dict[alias] = v
            pass
        else:
            new_key = snake_to_camel(k)
            if properties is not None and isinstance(properties, list) and new_key in properties:
                new_dict[new_key] = v
            else:
                new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
