# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class TransferredToAccountingStatus(str, Enum):
    """
    Status showing whether the journal entry has been transferred to an accounting system. This field cannot be changed after the summary journal entry has been cancelled. Note:** The Zuora Finance Override Transferred to Accounting permission is required to change `transferredToAccounting` from `Yes` to any other value.
    """

    """
    allowed enum values
    """
    NO = 'No'
    PROCESSING = 'Processing'
    YES = 'Yes'
    ERROR = 'Error'
    IGNORE = 'Ignore'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of TransferredToAccountingStatus from a JSON string"""
        return cls(json.loads(json_str))


