# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class ValidityPeriodType(str, Enum):
    """
    **Note**: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled.  The period in which the prepayment units are valid to use as defined in a [prepayment charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_prepayment_charge). 
    """

    """
    allowed enum values
    """
    SUBSCRIPTION_TERM = 'SUBSCRIPTION_TERM'
    ANNUAL = 'ANNUAL'
    SEMI_ANNUAL = 'SEMI_ANNUAL'
    QUARTER = 'QUARTER'
    MONTH = 'MONTH'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ValidityPeriodType from a JSON string"""
        return cls(json.loads(json_str))


